﻿package {
	import flash.display.Stage;
	import flash.events.KeyboardEvent;
	public class Key {
		private static var _stage:Stage;
		private static var keysDown:Object;
		private static var frame:uint=0;
		public static function init(st:Stage):void {
			_stage=st;
			if (keysDown==null) keysDown=new Object();
			st.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			st.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
		}
		
		private static function keyDownHandler(e:KeyboardEvent):void {
			keysDown["key"+e.keyCode] = true;
		}
		
		private static function keyUpHandler(e:KeyboardEvent):void {
			delete keysDown["key"+e.keyCode];
			delete keysDown["repeatFrame"+e.keyCode];
		}
		
		public static function isDown(keyCode:uint):Boolean {
			if (keysDown["repeat"+keyCode]==undefined) {
				// no repeat set so usual behaivor
				return keysDown["key"+keyCode]!=undefined;
			} else {
				// repeat only every repeat-frame
				if (keysDown["repeatFrame"+keyCode]!=undefined && frame>=keysDown["repeatFrame"+keyCode]) delete keysDown["repeatFrame"+keyCode];
				if (keysDown["repeatFrame"+keyCode]==undefined) {
					if (keysDown["key"+keyCode]!=undefined) {
						keysDown["repeatFrame"+keyCode]=frame+keysDown["repeat"+keyCode];
						return true;
					}
				}
				return false;
			}
		}
		
		public static function nextFrame():void {
			frame++;
		}
		
		public static function setKeyRepeat(keyCode:uint, frames:uint):void {
			if (keysDown==null) keysDown = new Object();
			if (frames ==0) {
				delete keysDown["repeat"+keyCode];
			} else {
				keysDown["repeat"+keyCode] = frames;
			}
		}
	}
}