﻿/*
====== READ THIS ========
This code was created as a part of the seminar on 
flash game programing at the University of Munich (Ludwig-
Maximlians Universität.

The code may be used for educational purposes only. All
rights reserverd by the author.

Author: Max Maurer
E-Mail: max.maurer@ifi.lmu.de
(c) 2011
If you have any questions don't hasitate to contact me.
=========================
*/
package {
	import flash.display.MovieClip;
	public class Tile extends MovieClip {
		public var tx:int;
		public var ty:int;
		private var blocks:MyMatrix;
		private var TILE_WIDTH:int=20;
		
		public function Tile ():void {
			tx=0;
			ty=0;
			blocks = new MyMatrix();
			var color:int = Math.random()*0xFFFFFF;
			createRandomTile(color);
		}
		
		private function createRandomTile(color:int):void {
			var tile:int = Math.floor(Math.random()*7);
			switch (tile) {
				case 0:
					// zick zack right
					addBlock(0,0,color);
					addBlock(0,1,color);
					addBlock(1,1,color);
					addBlock(1,2,color);
					break;
				case 1:
					// zick zack left
					addBlock(1,0,color);
					addBlock(1,1,color);
					addBlock(0,1,color);
					addBlock(0,2,color);
					break;
				case 2:
					// o
					addBlock(0,0,color);
					addBlock(0,1,color);
					addBlock(1,0,color);
					addBlock(1,1,color);
					break;
				case 3:
					// l
					addBlock(0,0,color);
					addBlock(0,1,color);
					addBlock(0,2,color);
					addBlock(1,2,color);
					break;
				case 4:
					// l-mirrored
					addBlock(1,0,color);
					addBlock(1,1,color);
					addBlock(1,2,color);
					addBlock(0,2,color);
					break;
				case 5:
					// tetris
					addBlock(0,0,color);
					addBlock(0,1,color);
					addBlock(0,2,color);
					addBlock(0,3,color);
					break;
				case 6:
					// triangle
					addBlock(1,0,color);
					addBlock(0,1,color);
					addBlock(1,1,color);
					addBlock(2,1,color);
					break;
			}
		}
		
		public function addBlock(tx:int,ty:int,color:int):void {
			// change those values depending on ration state
			var b:Block = new Block(color);
			b.x = tx*b.width;
			b.y = ty*b.height;
			addChild(b);
			blocks.setObject(tx,ty,b);
		}
		
		public function getWidth():int {
			return blocks.getWidth();
		}
		
		public function getHeight():int {
			return blocks.getHeight();
		}
		
		public function rotate():void {
			// rotate the tiles
			var newBlock:MyMatrix = new MyMatrix();
			var maxExtent:int = (getWidth()>getHeight())?getWidth():getHeight();
			for (var oldy:int=0;oldy<getHeight();oldy++) {
				for (var oldx:int=0;oldx<getWidth();oldx++) {
					// look here for algorithm: http://stackoverflow.com/questions/233850/tetris-piece-rotation-algorithm
					var oldBlock:Block=getBlock(oldx,oldy);
					if (oldBlock==null) continue;
					var newX:int = 1-(oldy-(maxExtent-2));
					var newY:int = oldx;
					newBlock.setObject(newX,newY,oldBlock);
				}
			}
			trace("rotated block");
			newBlock.cleanUp();
			blocks = newBlock;
			// set x and y of blocks to new values
			for (var y:int=0;y<getHeight();y++) {
				for (var x:int=0;x<getWidth();x++) {
					var b:Block=getBlock(x,y);
					if (b==null) continue;
					b.x = x*b.width;
					b.y = y*b.height;
				}
			}
		}
		
		public function getBlock(x:int,y:int):Block {
			return Block(blocks.getObject(x,y));
		}
		
		public function moveRight():void {
			moveX(1);
		}
		
		public function moveLeft():void {
			moveX(-1);
		}
		
		public function moveX(dx:int):void {
			tx+=dx;
			x=tx*TILE_WIDTH;
		}
		
		public function moveDown():void {
			ty++;
			y = ty*TILE_WIDTH;
		}
		
		public function move():void {
			moveDown();
		}
		
		

	}
}